unit E8253;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TEF8253 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
  procedure outport(portno:smallint;data:byte);
  function  inport(portno:smallint):byte;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EF8253: TEF8253;

implementation

{$R *.DFM}
procedure tEF8253.outport(portno:smallint;data:byte);
begin
asm
push dx
mov  dx,portno
mov  al,data
out  dx,al
pop  dx
end;
end;
function tEF8253.inport (portno:smallint):byte;
var
temp:byte;
begin
asm
push dx
mov  dx,portno
in  al,dx
mov temp,al
pop  dx
end;
inport := temp;
end;

procedure TEF8253.Button1Click(Sender: TObject);
begin
TIMER1.ENABLED := FALSE;
OUTPORT ($307,$10);
OUTPORT ($307,$50);
OUTPORT ($307,$90);       { TIMER 0,1,2 MODE 0 ( INTERRUPT )}
OUTPORT ($304,$F) ;
OUTPORT ($305,$F) ;
OUTPORT ($306,$F) ;       { LOAD COUNTER REGISTER }
TIMER1.ENABLED := TRUE ;

end;

procedure TEF8253.Button2Click(Sender: TObject);
begin
TIMER1.ENABLED := FALSE;
OUTPORT ($307,$12);
OUTPORT ($307,$52);
OUTPORT ($307,$92);     { TIMER 0,1,2 MODE 1 ( PROGRAMMABLE ONE SHOT) }
OUTPORT ($304,$F) ;
OUTPORT ($305,$F) ;
OUTPORT ($306,$F) ;     { LOAD COUNTER REGISTER }
TIMER1.ENABLED := TRUE ;

end;

procedure TEF8253.Button3Click(Sender: TObject);
begin
TIMER1.ENABLED := FALSE;
OUTPORT ($307,$14);
OUTPORT ($307,$54);
OUTPORT ($307,$94);    { TIMER 0,1,2 MODE 2( RATE GENERATOR )}
OUTPORT ($304,$F) ;
OUTPORT ($305,$F) ;
OUTPORT ($306,$F) ;    { LOAD COUNTER REGISTER }
TIMER1.ENABLED := TRUE ;

end;

procedure TEF8253.Button4Click(Sender: TObject);
begin
TIMER1.ENABLED := FALSE;
OUTPORT ($307,$18);
OUTPORT ($307,$58);
OUTPORT ($307,$98);{ TIMER 0,1,2 MODE 3 ( RATE GENERATOR WITH SQUARE WAVE) }
OUTPORT ($304,$F) ;
OUTPORT ($305,$F) ;    { LOAD COUNTER REGISTER }
OUTPORT ($306,$F) ;
TIMER1.ENABLED := TRUE ;

end;

procedure TEF8253.Button5Click(Sender: TObject);
begin
TIMER1.ENABLED := FALSE;
OUTPORT ($307,$1A);
OUTPORT ($307,$5A);
OUTPORT ($307,$9A); { TIMER 0,1,2 MODE 4 (SOFTWARE TRIGGERED  STROBE )}
OUTPORT ($304,$F) ;
OUTPORT ($305,$F) ;
OUTPORT ($306,$F) ;
TIMER1.ENABLED := TRUE ;

end;


procedure TEF8253.Button6Click(Sender: TObject);
begin
TIMER1.ENABLED := FALSE;
OUTPORT ($307,$10);
OUTPORT ($307,$50);
OUTPORT ($307,$90);     { TIMER 0,1,2 MODE 5 (HARDWARE TRIGGERED TROBE)}
OUTPORT ($304,$F) ;
OUTPORT ($305,$F) ;  { LOAD COUNTER REGISTER }
OUTPORT ($306,$F) ;
TIMER1.ENABLED := TRUE ;

end;


procedure TEF8253.Timer1Timer(Sender: TObject);
begin
OUTPORT ($307,$F);                {  LATCH COUNTER }
LABEL5.CAPTION := INTTOSTR (INPORT($304));              {READ DATA}
OUTPORT ($307,$F);                 {  LATCH COUNTER }
LABEL6.CAPTION := INTTOSTR (INPORT($305));              {READ DATA}
OUTPORT ($307,$F);                 {  LATCH COUNTER }
LABEL7.CAPTION := INTTOSTR (INPORT($306));              {READ DATA}
end;

end.
